#!/bin/bash

# cleaning up

if [ -f distkeygen/distkeygen ]
 then
 rm distkeygen/distkeygen
fi

if [ -f eatmem/eatmem ]
 then
 rm eatmem/eatmem
fi

if [ -f fork/forkit ]
 then
 rm fork/forkit
fi

if [ -f timewaster/timewaster ]
 then
 rm timewaster/timewaster
fi


# install required perl-modules
echo "This openMosix test-suite requires the"
echo "Parallel-ForkManager + Statistics-Descriptive-Discrete"
echo "Perl-modules!"
echo "Both modules will be installed now."
echo "(press return for ok, ctr-c for cancel)"
read

cd required/Parallel-ForkManager-0.7.4
perl Makefile.PL
make
make install
cd ../Statistics-Descriptive-Discrete-0.07
perl Makefile.PL
make
make install
cd ../../
echo "required perl-modules are installed now"


# start compiling
echo "compiling distkeygen"
cd distkeygen
./compile.sh
cd ..

echo "compiling eatmem"
cd eatmem
./compile.sh
cd ..

echo "compiling forkit"
cd fork
./compile.sh
cd ..

echo "compiling timewaster"
cd timewaster
./compile.sh
cd ..

echo "compiling kernel + syscall test"
cd ltp
./compile.sh
cd ..

echo "compiling lmbench"
cd lmbench
./compile.sh
cd ..

echo
echo "Installation finished!"
echo "you can run :"
echo "./start_openMosix_test.sh"
echo "to start the stress test on your cluster now"
echo 


